# This file is part of frama-c-sv,
# a wrapper around Frama-C that makes it possible
# to execute Frama-C as part of the Competition on Software Verification:
# https://gitlab.com/sosy-lab/software/frama-c-sv
#
# SPDX-FileCopyrightText: 2021 Dirk Beyer <https://www.sosy-lab.org>
#
# SPDX-License-Identifier: Apache-2.0

import re
import pandas as pd

from util import Property

RESULT_TRUE_PROP = "true"
RESULT_FALSE_PROP = "false"
RESULT_UNKNOWN = "unknown"
RESULT_ERROR = "error"
RESULT_FALSE_OVERFLOW = RESULT_FALSE_PROP + "(no-overflow)"
RESULT_FALSE_DEREF = RESULT_FALSE_PROP + "(valid-deref)"


class OutputInterpreter:
    def __init__(self, property_):
        self.property = property_

    def interpret(self, lines):
        if self.property == Property.UNREACH_CALL:
            return self._interpret_unreach_call(lines)
        elif self.property == Property.NO_OVERFLOW:
            return self._interpret_no_overflow(lines)
        elif self.property == Property.MEMORY_SAFETY:
            return self._interpret_memory_safety(lines)
        elif self.property == Property.TERMINATION:
            return self._interpret_termination(lines)
        elif self.property == Property.VALID_ACSL:
            return self._interpret_valid_acsl(lines)
        else:
            return f"{RESULT_UNKNOWN}(property)"

    def _interpret_unreach_call(self, lines):
        return RESULT_UNKNOWN

    def _interpret_no_overflow(self, lines):
        return RESULT_UNKNOWN

    def _interpret_memory_safety(self, lines):
        return RESULT_UNKNOWN

    def _interpret_termination(self, lines):
        return RESULT_UNKNOWN

    def _interpret_valid_acsl(self, lines):
        return RESULT_UNKNOWN


# deprecated, use ReportInterpreter instead!
class ScandiumInterpreter(OutputInterpreter):
    def interpret(self, lines):
        text = "".join(lines)
        crashed = "Please report as 'crash'" in text
        recursive = "detected recursive call" in text
        m = re.search(
            r"by the Frama-C kernel:\s*([0-9]*)\s*error[s]?\s*([0-9]*)\s*warning", text
        )
        if crashed:
            return RESULT_UNKNOWN + "(crash)"
        if recursive:
            return RESULT_UNKNOWN + "(recursion)"
        if m:
            warnings = int(m.group(2))
            errors = int(m.group(1))
        elif "No errors or warnings raised during the analysis." in text:
            warnings = 0
            errors = 0
        else:
            return RESULT_UNKNOWN + "(nostats)"

        m = re.search("([0-9]*) alarm[s]? generated by the analysis", text)
        if m:
            alarms = int(m.group(1))
        else:
            return RESULT_UNKNOWN + "(nostats)"

        if errors + warnings + alarms == 0:
            if self.property == Property.NO_OVERFLOW:
                if "assertion 'rte,signed_overflow' got final status invalid" in text:
                    # or "signed overflow. assert" in text:
                    return RESULT_FALSE_OVERFLOW
            elif self.property == Property.MEMORY_SAFETY:
                # do not even bother to check for the existence of the other two now
                # "assertion 'alloca_bounds' got status invalid (stopping propagation)"
                # in text
                # or if "assertion 'Eva,initialization' got final status invalid"
                # in text or "accessing uninitialized left-value." in text:
                if "assertion 'rte,mem_access' got final status invalid" in text:
                    return RESULT_FALSE_DEREF
            elif self.property == Property.UNREACH_CALL:
                if "No logical properties have been reached by the analysis." in text:
                    return RESULT_TRUE_PROP
                elif " 0% of the logical properties reached have been proven." in text:
                    return RESULT_FALSE_PROP
            if (
                "No errors or warnings raised during the analysis" in text
                or "100% of the logical properties reached have been proven" in text
            ):
                return RESULT_TRUE_PROP
            else:
                return RESULT_UNKNOWN

        parts = []
        if errors > 0:
            parts.append("%d errors" % errors)
        if warnings > 0:
            parts.append("%d warnings" % warnings)
        if alarms > 0:
            parts.append("%d alarms" % alarms)
        detail = "(" + ", ".join(parts) + ")"
        return RESULT_UNKNOWN + detail


# deprecated, use ReportInterpreter instead!
class CalciumInterpreter(OutputInterpreter):
    def _interpret_no_overflow(self, lines):
        text = "".join(lines)
        has_error = "(unexpected)" if "Unexpected error" in text else None
        has_crash = "(crash)" if "Please report as 'crash'" in text else None
        is_recursive = "(recursive)" if "detected recursive call" in text else None
        unknown = has_crash or is_recursive
        m = re.search("([0-9]*) alarm[s]? generated by the analysis", text)
        alarms = 0
        if m:
            alarms = int(m.group(1))
            detail = "(%s alarms)" % m.group(1)
        if "assertion 'rte,signed_overflow' got final status invalid" in text:
            return RESULT_FALSE_OVERFLOW
        if has_error:
            return RESULT_ERROR + has_error
        if unknown:
            return RESULT_UNKNOWN + unknown
        if alarms != 0:
            return RESULT_UNKNOWN + detail
        return RESULT_TRUE_PROP

    def _interpret_unreach_call(self, lines):
        result = list(filter(lambda line: "Pre-condition 'unreach'\n" in line, lines))
        if len(result) != 1:
            return RESULT_UNKNOWN
        return RESULT_TRUE_PROP if "Valid" in result[0] else RESULT_FALSE_PROP


class ReportInterpreter(OutputInterpreter):
    def __init__(self, property_, report):
        super().__init__(property_)
        self.report = report

    def preprocess(self):
        if not self.report.is_file():
            return None
        df = pd.read_csv(self.report, delimiter="\t")
        df = df.loc[
            (df["directory"].str.endswith("output")) & (df["file"] == "program.c")
        ]
        return df[["function", "property kind", "status", "property"]]

    def interpret(self, lines):
        text = "".join(lines)
        if "Please report as 'crash'" in text:
            return RESULT_ERROR + "(crash)"
        elif "Unexpected error" in text:
            return RESULT_ERROR + "(unexpected)"
        elif "detected recursive call" in text:
            return RESULT_UNKNOWN + "(recursive)"
        else:
            return super().interpret(lines)

    def _interpret_valid_acsl(self, lines):
        df = self.preprocess()
        if df is None or df.empty:
            return RESULT_ERROR
        df = df.loc[(df["function"] != "abort") & (df["function"] != "__assert_fail")]
        results = df["status"].tolist()
        if all([r == "Valid" or r == "Considered Valid" for r in results]):
            return RESULT_TRUE_PROP
        elif any(["Invalid" in r for r in results]):
            return RESULT_FALSE_PROP
        else:
            return RESULT_UNKNOWN

    def _interpret_unreach_call(self, lines):
        df = self.preprocess()
        if df is None or df.empty:
            return RESULT_ERROR
        df = df.loc[
            (df["function"] == "reach_error") & (df["property kind"] == "precondition")
        ]
        results = df["status"].tolist()
        if len(results) != 1:
            return RESULT_UNKNOWN
        result = results[0]
        if result == "Valid":
            return RESULT_TRUE_PROP
        elif "Invalid" in result:
            return RESULT_FALSE_PROP
        else:
            return RESULT_UNKNOWN

    def _interpret_no_overflow(self, lines):
        df = self.preprocess()
        if df is None or df.empty:
            return RESULT_ERROR
        overflow_props = {x for x in df["property kind"] if "overflow" in x}
        df = df[df["property kind"].isin(overflow_props)]
        reach = df.loc[(df["function"] == "reach_error")]
        if not reach.empty:
            results = reach["status"].tolist()
            if len(results) == 1:
                result = results[0]
                if result == "Dead":
                    return RESULT_TRUE_PROP
                elif result == "Invalid or unreachable":
                    # This case is ambiguous
                    return RESULT_UNKNOWN
                else:
                    return RESULT_UNKNOWN
        results = df["status"].tolist()
        if any("Invalid" in x for x in results):
            return RESULT_FALSE_PROP
        elif all(x in ["Valid", "Dead", "Considered valid"] for x in results):
            return RESULT_TRUE_PROP
        else:
            return RESULT_UNKNOWN

    def _interpret_memory_safety(self, lines):
        df = self.preprocess()
        if df is None or df.empty:
            return RESULT_ERROR
        mem_props = {x for x in df["property kind"] if "mem_access" in x}
        df = df[df["property kind"].isin(mem_props)]
        results = df["status"].tolist()
        if any("Invalid" in x for x in results):
            return RESULT_FALSE_PROP
        elif all(x == "Valid" for x in results):
            return RESULT_TRUE_PROP
        else:
            return RESULT_UNKNOWN
